DECLARE SUB Delay (secsdelay AS INTEGER)
DEFINT A-Z

OPEN "COM1: 75,N,8,2, OP0,CD0,CS0,DS0" FOR RANDOM AS #1
WIDTH #1, 255

comx = &H3F8                    ' COM1 = &H3F8     COM2 = &H2F8
                                ' COM3 = &H3E8     COM4 = &H2E8
pulse = 5                       ' start with 50ms pulse

CLS
lasttime = 55                   ' ensure open/closed message displayed
LOCATE 2, 18: PRINT "ECD -  SELF-POWERED CASH DRAWER INTERFACE V3.0";
LOCATE 13, 15: PRINT "Allow 20 seconds for interface to charge up";
LOCATE 25, 5: PRINT "Press SPACE BAR to open drawer, +/- to set pulse width, Q to Quit";

Delay 20
secsdelay = 5
LOCATE 13, 1: PRINT SPC(79);

pulseloop:
LOCATE 23, 31: PRINT "Pulse Width="; STR$(pulse) + "0ms";

ctsloop:                        ' Read CTS to see if drawer is open/closed

drawer = (INP(comx + 6) AND &H10)
IF drawer = 0 THEN SOUND 261, 1' continuous tone whilst draw open
IF drawer = lasttime THEN GOTO getkey ELSE lasttime = drawer

LOCATE 13, 30
IF drawer = 0 THEN PRINT "The draw is open  " ELSE PRINT "The draw is closed"

getkey:
x$ = INKEY$: IF x$ = "" THEN GOTO ctsloop     ' wait for user to press a key
IF x$ = "q" OR x$ = "Q" THEN CLS : SYSTEM     ' Quit if 'Q'or 'q' pressed
IF x$ = "+" THEN
        pulse = pulse + 1:
        IF pulse > 9 THEN pulse = 9
        GOTO pulseloop
END IF
IF x$ = "-" THEN
        pulse = pulse - 1:
        IF pulse < 1 THEN pulse = 1
        GOTO pulseloop
END IF

IF x$ = " " THEN
  PRINT #1, CHR$(&H100 - (2 ^ (pulse - 1)));
  Delay 5
END IF

GOTO ctsloop

SUB Delay (secsdelay AS INTEGER)
  ' force a wait of n seconds
  start! = TIMER
  FOR x = 1 TO secsdelay
        LOCATE 21, 31: PRINT "Please wait..."; secsdelay - x + 1;
        WHILE INT(TIMER - start!) < x: WEND
  NEXT
  LOCATE 21, 31: PRINT SPC(30);
  WHILE INKEY$ <> "": WEND

END SUB

